/**********************************************************************
  PPClCeBu߃Zbg V~[^
  $Id: main.c,v 1.10 2002/11/11 17:47:40 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"
#include "cmd_funcs.h"
#include "version.h"

#ifdef __human__
#define	PLATFORM	"X68k"
#else
#ifdef __CYGWIN__
#define	PLATFORM	"Cygwin"
#else
#define	PLATFORM	"AnyHost"
#endif
#endif

#define	FNAME_LENG	1024
#define	FILE_NUM	64
#define ARG_NUM         64

void manprint() ;

int main(int argc,char *argv[])
{
  int           i,j ;
  unsigned char *workp ;
  int           argread ;
  unsigned char infname[FILE_NUM][FNAME_LENG] ;
  int           file_num ;
  unsigned char *inarg[ARG_NUM] ;
  int           arg_num ;

  argread=0 ;
  arg_num=0 ;
  file_num=0 ;
  simlog=NULL ;
  x_path = get_xpath( argv[0] ) ;

  set_initparams() ;
  
  for( i=1 ; i<argc ; i++ ){
    workp = argv[i] ;
    if( *workp == '-' && argread==0 ) {
      workp++ ;
      switch( *workp ){
      case 'h' :
	manprint() ;
	exit(0) ;
	break ;
      case 'x' :
	argread=1 ;
	break ;
      case 'o' :
	i++ ;
	if( argc==i ) break ;
	j=strlen(argv[i]+1) ;
	simlog=malloc(j+1) ;
	strcpy(simlog,argv[i]) ;
	break ;
      case 'M' :
	i++ ;
	if( argc==i ) break ;
	default_textsize=exatoi(argv[i]) ;
	break ;
      case 'H' :
	i++ ;
	if( argc==i ) break ;
	default_heaptop=exatoi(argv[i]) ;
	break ;
      case 'P' :
	i++ ;
	if( argc==i ) break ;
	default_heapsize=exatoi(argv[i]) ;
	break ;
      case 'E' :
	i++ ;
	if( argc==i ) break ;
	default_exec_start=exatoi(argv[i]) ;
	break ;
      case 'S' :
	i++ ;
	if( argc==i ) break ;
	default_stack_top_offset=exatoi(argv[i]) ;
	break ;
      case 'L' :
	default_exec_start = 0x10000100 ;
	sc_emu_mode        = LINUXPPC ;
      }
    }else{
      if( argread==0 ){
	workp = infname[file_num] ;
	for( j=0 ; j < FNAME_LENG ; j++ ) *workp++ = '\0' ; /*  */
	strcpy( infname[file_num++] , argv[i] ) ;
	if( file_num==FILE_NUM ){
	  SYSERR("Number of file arguments over the system restriction(=%d)\n",FILE_NUM) ;
	  break ;
	}
      }else{
	int wordlen ;
	wordlen=strlen(argv[i]) ;
	inarg[arg_num]=malloc(wordlen+1) ;
	if( inarg[arg_num]==NULL ) exit(-1) ;
	strcpy(inarg[arg_num],argv[i]) ;
	arg_num++ ;
      }
    }
  }
  //setmode( fileno(stdout),O_BINARY ) ;

  if( init_system()!=NORMAL_EXIT ) exit(0) ;

  /*** arg exec mode ***/
  if( argread!=0 ){
    int total ;
    unsigned char *buf ;
    struct	TOKEN_STRUCT	token ;

    if( arg_num==0 ) exit(0) ;
    total=0 ;
    for( i=0 ; i<arg_num ; i++ ){
      total+=strlen(inarg[i])+1 ;
    }
    buf=malloc(total+8) ;
    if( buf==NULL ) exit(-1) ;
    strcpy(buf,"exec") ;
    for( i=0 ; i<arg_num ; i++ ){
      sprintf(buf,"%s %s",buf,inarg[i]) ;
    }
    get_token( buf, &token ) ;
    exec_cmd( &token, GO_EXEC_MODE ) ;
  }
  /*** shell exec mode ***/
  else if( file_num == 0 ){
    cmd_exec( "-\0" ) ;	/*** C^NeBu[h ***/
  }else{
    for( i=0 ; i<file_num ; i++ ){
      cmd_exec( infname[i] ) ;
    }
  }
  exit(0) ;
}

void manprint()
{
  SYSERR("PPC Simulator for " PLATFORM " " VERSION " TANE\n"
	 "Usage: ppcsim [-Options] [file....] [-x cmd arg1 arg2 ....]\n"
	 " Options\n"
	 "  -M num : Change default memory size for exec command & fork emulate\n"
	 "  -H num : Change default heap top for sbrk emulate\n"
	 "  -P num : Change default heap size for sbrk emulate\n"
	 "  -E num : Change default execute start address for exec command & fork emulate\n"
	 "  -S num : Change default stack offset\n"
	 "  -L     : Change to Linux Syscall Emulation mode\n"
	 "  -o log : Simulation log message output to file(default=stderr)\n"
	 "  -x ... : start direct exec() mode. \n"
	 "  -h     : This help\n"
	 "\n"
	 " if file(s) or -x option is not specified, it start with interactive shell mode.\n") ;
}
