/**********************************************************************
  memal }V̊蓖
  $Id: memal.c,v 1.2 2002/11/03 03:57:35 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	memal( struct MACHINE_RESOURCE *mres , int seg, int size, int attr )
{
  int   i,j,k,amt ;

  i=size ;
  if( i>0 ){
    amt=i ;
    for( j=seg ; j<MEM_SEGMENT_NUM ; j++ ){
      if( amt/MEM_SEGMENT_SIZE !=0 ){
	k=MEM_SEGMENT_SIZE ;
      }else{
	k=amt ;
      }
      if( mres->mem[j]!=NULL ){
	free(mres->mem[j]) ;
	mres->mem[j]     =NULL ;
	mres->mem_size[j]=0 ;
      }
      mres->mem[j]=malloc(k) ;
      if( mres->mem[j]==NULL ){
	return(MEM_ALLOC_ERROR) ;
      }
      mres->mem_size[j]=k ;
      mres->mem_attr[j]=attr ;
      memclear( mres, j, k ) ;
      amt-=MEM_SEGMENT_SIZE ;
      if( amt<=0 ) break ;
    }
  }else{
    return(SPECIFY_ERROR) ;
  }
  
  return( NORMAL_EXIT ) ;
}

int	memclear( struct MACHINE_RESOURCE *mres , int seg, int size )
{
  int   i,j,k,amt ;

  i=size ;
  if( i>0 ){
    amt=i ;
    for( j=seg ; j<MEM_SEGMENT_NUM ; j++ ){
      if( amt/MEM_SEGMENT_SIZE !=0 ){
	k=MEM_SEGMENT_SIZE ;
      }else{
	k=amt ;
      }
      if( mres->mem[j]==NULL ){
	break ;
      }
      if( mres->mem_size[j]<k ){
	memset(mres->mem[j], 0, mres->mem_size[j] ) ;
	break ;
      }
      memset( mres->mem[j], 0, k ) ;

      amt-=MEM_SEGMENT_SIZE ;
      if( amt<=0 ) break ;
    }
  }else{
    return(SPECIFY_ERROR) ;
  }
  
  return( NORMAL_EXIT ) ;
}
