/**********************************************************************
  ߃fR[h  bit0-5=0b10xxxx
  $Id: op_2x_func.c,v 1.4 2002/11/11 17:47:40 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "sim_io.h"

int op_20_func( struct MACHINE_RESOURCE *mres , int mode ) /* lwz */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu4b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_21_func( struct MACHINE_RESOURCE *mres , int mode ) /* lwzu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu4b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_22_func( struct MACHINE_RESOURCE *mres , int mode ) /* lbz */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu1b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_23_func( struct MACHINE_RESOURCE *mres , int mode ) /* lbzu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu1b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_24_func( struct MACHINE_RESOURCE *mres , int mode ) /* stw */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu4b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_25_func( struct MACHINE_RESOURCE *mres , int mode ) /* stwu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu4b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_26_func( struct MACHINE_RESOURCE *mres , int mode ) /* stb */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu1b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }

  return(0) ;
}


int op_27_func( struct MACHINE_RESOURCE *mres , int mode ) /* stbu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu1b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_28_func( struct MACHINE_RESOURCE *mres , int mode ) /* lhz */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_29_func( struct MACHINE_RESOURCE *mres , int mode ) /* lhzu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchu2b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2a_func( struct MACHINE_RESOURCE *mres , int mode ) /* lha */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchs2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2b_func( struct MACHINE_RESOURCE *mres , int mode ) /* lhau */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    fetchs2b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2c_func( struct MACHINE_RESOURCE *mres , int mode ) /* sth */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu2b(mres->GPR[r1].rl,ea) ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2d_func( struct MACHINE_RESOURCE *mres , int mode ) /* stbu */
{
  unsigned int r1,r2,d,ea ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g
  
  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      return( INSTFORM_IS_INVALID ) ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    
    storeu2b(mres->GPR[r1].rl,ea) ;
    mres->GPR[r2].rl=ea ;
    
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2e_func( struct MACHINE_RESOURCE *mres , int mode ) /* lmw */
{
  unsigned int r1,r2,d,ea ;
  int i ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    for( i=r1 ; i<32 ; i++ ){
      fetchu4b(mres->GPR[i].rl,ea) ;
      ea+=4 ;
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}


int op_2f_func( struct MACHINE_RESOURCE *mres , int mode ) /* stmw */
{
  unsigned int r1,r2,d,ea ;
  int i ;
  
  r1= (mres->inst & 0x03e00000)>>21 ;
  r2= (mres->inst & 0x001f0000)>>16 ;
  d = (mres->inst & 0x0000ffff) ;
  if( (d & 0x00008000)!=0 ) d=d | 0xffff0000 ; //g

  if( DO_EXEC_DIS(mode) ){
    dis_print_rrd(r1,r2,d) ;
  }
  
  if( DO_EXEC_INST(mode) ){
    if( r2==0 ){
      ea = d ;
    }else{
      ea = mres->GPR[r2].rl+d ;
    }
    for( i=r1 ; i<32 ; i++ ){
      storeu4b(mres->GPR[i].rl,ea) ;
      ea+=4 ;
    }
    mres->pc+=4 ;
  }
  
  return(0) ;
}
