/**********************************************************************
  VXeR[G~[V
   for newlib based Standard C library
  $Id: op_scemu.c,v 1.5 2002/11/11 17:47:41 tane Exp $
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"
#include "op_exec.h"
#include "op_scemu.h"
#include <sys/time.h>
#include <sys/times.h>

#ifdef HOST_ORDER_IS_LITTLE_ENDIAN
#define SWAP2B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[1];((char*)&a)[1]=t;}
#define SWAP4B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[3];((char*)&a)[3]=t;\
                           t=((char*)&a)[1];((char*)&a)[1]=((char*)&a)[2];((char*)&a)[2]=t;}
#define SWAP8B(a)  {char t;t=((char*)&a)[0];((char*)&a)[0]=((char*)&a)[7];((char*)&a)[7]=t;\
                           t=((char*)&a)[1];((char*)&a)[1]=((char*)&a)[6];((char*)&a)[6]=t;\
                           t=((char*)&a)[2];((char*)&a)[2]=((char*)&a)[5];((char*)&a)[5]=t;\
                           t=((char*)&a)[3];((char*)&a)[3]=((char*)&a)[4];((char*)&a)[4]=t;}
#else
#define SWAP2B(a)
#define SWAP4B(a)
#define SWAP8B(a)
#endif

void stat_cpyto32( struct stat *st , struct MACHINE_RESOURCE *mres, unsigned int adrs ) ;
void stat_cpyto64( struct stat *st , struct MACHINE_RESOURCE *mres, unsigned int adrs ) ;

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres ) ;
void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void set_DIR_entry( unsigned int adrs , DIR *dirpt ) ;
void remove_DIR_entry( unsigned int adrs ) ;
DIR* search_DIR_entry( unsigned int adrs ) ;
void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;
void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs ) ;

int	op_scemu( struct MACHINE_RESOURCE *mres )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
static int top_fd=0 ;
int	   ret ;

 if( truss_stat==ON ) SYSMSG("%08x:Syscall_NO=%d\n  ",mres->pc,mres->GPR[0].rl) ;
 switch( mres->GPR[0].rl ){
   int mode1,mode2 ;
   int size ;
 case 1: // exit()
   if( truss_stat==ON ) SYSMSG("exit(%x)\n",mres->GPR[3].rl) ;
   return(SYSCALLED_EXIT) ;
 case 2: // fork()
   if( truss_stat==ON ) SYSMSG("fork()\n") ;
   mres->pc+=4 ;
   return(SYSCALLED_FORK) ;
 case 3 : // read()
   if( truss_stat==ON ){
     SYSMSG("Read_fd=%d+%d 0x%08x,0x%08x",
	    mres->GPR[3].rl,top_fd,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = read( (int)mres->GPR[3].rl+top_fd,
	       &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
	       (unsigned int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   if( truss_stat==ON ){ SYSMSG("  ==> ret 0x%08x\n",ret ); }
   mres->pc+=4 ; return(0) ;
 case 4 : // write()
   if( truss_stat==ON ){
     SYSMSG("Write_fd=%d+%d 0x%08x,0x%08x\n",
	    mres->GPR[3].rl,top_fd,mres->GPR[4].rl,mres->GPR[5].rl) ;
   }
   ret = write( (int)mres->GPR[3].rl+top_fd,
		&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)],
		(unsigned int)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 5: // open()
   open_mode_exchg( &mode1 , &mode2 , mres ) ;
   if( truss_stat==ON ){
     SYSMSG("Opened_Name=%s,0x%x,0x%x\n",&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],mode1,mode2) ;
   }
   ret = open( &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], mode1, mode2) ;
   if( truss_stat==ON ) SYSMSG("  >>Opend_fd=%d+%d\n",ret,top_fd) ;
   mres->GPR[3].rl = ret - top_fd ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 6: // close()
   if( truss_stat==ON ) SYSMSG("Close_fd=%d+%d\n",mres->GPR[3].rl,top_fd) ;
   if( mres->GPR[3].rl>=0 && mres->GPR[3].rl<3 ){
     /** WION[YȂlɂ **/
     if( truss_stat==ON ){
       SYSMSG("Close_fd is STDIO. close() exec is blocked by close() emulator.\n") ;
     }
     ret=0 ;
   }else{
     ret = close( (int)mres->GPR[3].rl+top_fd ) ;
   }
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 10: // unlink()
   if( truss_stat==ON ) SYSMSG("unlink() not implement yet.\n") ;
   mres->GPR[3].rl = 0 ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 11: // execve()
   if( truss_stat==ON ) SYSMSG("execve\n") ;
   mres->pc+=4 ;
   return(SYSCALLED_EXECVE) ;
 case 12: // chdir()
   if( truss_stat==ON ) SYSMSG("chdir( %s )\n",(char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)]) ;
   ret = chdir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 13: // time()
   if( truss_stat==ON ) SYSMSG("time( 0x%x )\n",mres->GPR[3].rl) ;
   {
     unsigned char *ptr=&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ;
     ret = time( (time_t *)ptr ) ;
     SWAP4B( ptr[0] ) ;
   }
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 15: // chmod()
   if( truss_stat==ON ){
     SYSMSG("chmod( %s , 0x%x )\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   ret = chmod( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 19: // lseek()
   if( truss_stat==ON ){
     SYSMSG("lseek_fd=%d+%d 0x%08x,0x%08x",
	    mres->GPR[3].rl,top_fd, mres->GPR[4].rl,mres->GPR[5].rl ) ;
   }
   ret = lseek( (int)mres->GPR[3].rl+top_fd,
		(off_t)mres->GPR[4].rl,
		(int)mres->GPR[5].rl ) ;
   if( truss_stat==ON ){
     SYSMSG(" ==> ret 0x%08x\n",ret) ;
   }
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 20: // getpid() for linux ELF
   if( truss_stat==ON ){
     SYSMSG("getpid=%d+%d 0x%08x,0x%08x\n",
	    mres->GPR[3].rl,top_fd, mres->GPR[4].rl,mres->GPR[5].rl ) ;
   }
   mres->GPR[3].rl = 100 ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 24: // getuid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getuid()\n") ;
   mres->GPR[3].rl = 500 ; // hard cording
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 30: // utime()
   if( truss_stat==ON ){
     SYSMSG("utime( %s , 0x%x )\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl ) ;
   }
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   ret = utime( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(struct utimbuf *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timbuf_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 43: // times()
   if( truss_stat==ON ) SYSMSG("times( 0x%08x ).\n",(int)mres->GPR[3].rl) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   ret = times( (struct tms *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
   tm_exchg( mres, mres->GPR[3].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 45: // brk() for linux ELF
   if( truss_stat==ON ) SYSMSG("brk(0x%08x)",(int)mres->GPR[3].rl) ;
   size=(int)mres->GPR[3].rl ;
   mres->GPR[3].rl = 0 ;
   mres->GPR[0].rl = 0 ;
   if( truss_stat==ON ) SYSMSG("===> ret(0x%08x)\n",(int)mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 47: // getgid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getgid( 0x%08x ).\n",(int)mres->GPR[3].rl) ;
   mres->GPR[3].rl = 544 ; // hard cording
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 49: // geteuid() for linux ELF
   if( truss_stat==ON ) SYSMSG("geteuid( 0x%08x ).\n",(int)mres->GPR[3].rl) ;
   mres->GPR[3].rl = 500 ; // hard cording
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 50: // getegid() for linux ELF
   if( truss_stat==ON ) SYSMSG("getegid( 0x%08x ).\n",(int)mres->GPR[3].rl) ;
   mres->GPR[3].rl = 544 ; // hard cording
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 54: // ioctl()
   if( truss_stat==ON ) SYSMSG("ioctl is not implement yet.\n") ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
   //   mres->pc+=4 ; return(UNKNOWN_SYSCALL_NO) ;
 case 55: // fcntl()
   if( truss_stat==ON ) SYSMSG("fcntl_fl=%d+%d\n",mres->GPR[3].rl,top_fd) ;
   ret = fcntl( (int)mres->GPR[3].rl+top_fd,
		(int)mres->GPR[4].rl,
		(int)mres->GPR[5].rl,
		(int)mres->GPR[6].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 77: // getrusage() for linux ELF
   if( truss_stat==ON ) SYSMSG("getrusage( 0x%08x , 0x%08x ).\n",
				(int)mres->GPR[3].rl,(int)mres->GPR[4].rl) ;
   mres->GPR[3].rl = 0 ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 78: // gettimeofday()
   if( truss_stat==ON ) SYSMSG("gettimeofday( 0x%08x , 0x%08x ).\n",
				(int)mres->GPR[3].rl,(int)mres->GPR[4].rl) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   ret = gettimeofday( (struct timeval  *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		       (struct timezone *)&mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)] ) ;
   timeval_exchg(  mres, mres->GPR[3].rl ) ;
   timezone_exchg( mres, mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 89: // readdir()
   if( truss_stat==ON ){
     SYSMSG("readdir(0x%x).\n", mres->GPR[3].rl ) ;
   }
   {
     struct dirent *dp ;
     DIR_exchg( mres, mres->GPR[3].rl ) ;
     dp = readdir( (DIR *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
     DIR_exchg( mres, mres->GPR[3].rl ) ;
     if( dp==NULL ) mres->GPR[3].rl=0 ;
     else{
       mres->GPR[3].rl=mres->GPR[4].rl ; /** dpԂ **/
       dirent_exchg( mres, mres->GPR[4].rl ) ;
       memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dp, sizeof(struct dirent) ) ;
       dirent_exchg( mres, mres->GPR[4].rl ) ;
     }
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 90: // mmap() for linux ELF
   if( truss_stat==ON ) SYSMSG("mmap(%08x,%08x,%08x,%08x,%08x,%08x)",
			       mres->GPR[3].rl,mres->GPR[4].rl,mres->GPR[5].rl,
			       mres->GPR[6].rl,mres->GPR[7].rl,mres->GPR[8].rl) ;
   mres->GPR[3].rl = sim_mmap( mres,
			       mres->GPR[3].rl,    //_addr
			       mres->GPR[4].rl,    //_len
			       mres->GPR[5].rl,    //_prot
			       mres->GPR[6].rl,    //_flags
			       mres->GPR[7].rl,    //_fd
			       mres->GPR[8].rl ) ; //_off
   if( truss_stat==ON ) SYSMSG("===> ret(0x%08x)\n",(int)mres->GPR[3].rl) ;
   if( mres->GPR[3].rl==0xffffffff ){
     mres->GPR[0].rl = 12 ; /** ENOMEM **/
   }else{
     mres->GPR[0].rl = 0 ;
   }
   mres->pc+=4 ; return(0) ;
 case 91: // munmap() for linux ELF
   if( truss_stat==ON ) SYSMSG("munmap(0x%08x,0x%08x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   mres->GPR[3].rl= sim_munmap( mres,
      			        mres->GPR[3].rl,    //_addr
      				mres->GPR[4].rl ) ; //_len
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 125: // _mprotect() for linux ELF
   if( truss_stat==ON ) SYSMSG("mprotect()\n") ;
   mres->GPR[3].rl = 0 ;
   mres->GPR[0].rl = 0 ;
   mres->pc+=4 ; return(0) ;
 case 140: // llseek() for linux ELF
   if( truss_stat==ON ){
     SYSMSG("llseek_fd=%d+%d 0x%08x,0x%08x",
	    mres->GPR[3].rl,top_fd, mres->GPR[5].rl,mres->GPR[7].rl ) ;
   }
   ret = lseek( (int)mres->GPR[3].rl+top_fd,
		(off_t)mres->GPR[5].rl,
		(int)mres->GPR[7].rl ) ;
   if( (ret & 0x80000000)!=0 ){
     mres->GPR[3].rl = 0xffffffff ;
   }else{
     mres->GPR[3].rl = 0x0 ;
   }
   mres->GPR[4].rl = ret ;
   mres->GPR[0].rl = errno ;
   if( truss_stat==ON ){
     SYSMSG("   ret===> 0x%08x_%08x\n",mres->GPR[3].rl,mres->GPR[4].rl ) ;
   }
   mres->pc+=4 ; return(0) ;
 case 205: // _opendir()
   if( truss_stat==ON ){
     SYSMSG("opendir(0x%x,0x%x).\n", mres->GPR[3].rl, mres->GPR[4].rl ) ;
   }
   {
     DIR *dirp ;

     DIR_exchg( mres, mres->GPR[4].rl ) ;
     dirp = opendir( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)] ) ;
     if( dirp==NULL ) mres->GPR[3].rl=0 ;
     else{
       set_DIR_entry( mres->GPR[4].rl , dirp ) ;
       mres->GPR[3].rl=mres->GPR[4].rl ; /** PPCdirpԂ **/
       memcpy( &mres->mem[seg(mres->GPR[4].rl)][lad(mres->GPR[4].rl)], dirp, sizeof(DIR) ) ;
     }
     DIR_exchg( mres, mres->GPR[4].rl ) ;
     /*CygwinŃt@CGg(dirent̃Xg)ێĂ炵̂
       dirpV~[^ɕێĂAclosedir()͎sĂ͂ȂȂ*/
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 206: // closedir()
   if( truss_stat==ON ){
     SYSMSG("closedir(0x%x).\n", mres->GPR[3].rl ) ;
   }
   {
     DIR *dirp ;
     dirp=search_DIR_entry( mres->GPR[3].rl ) ;
     if( dirp==NULL ){
       SYSMSG("closedir() emulator internal error?.\n") ;
     }
     ret = closedir( dirp ) ;
     //SYSMSG("closedir ret = %x.\n", ret ) ;
     remove_DIR_entry( mres->GPR[3].rl ) ;
     mres->GPR[3].rl = ret ;
   }
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 106: // stat()
   if( truss_stat==ON ){
     SYSMSG("stat(%s,0x%x)\n",&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	                      mres->GPR[4].rl) ;
   }
   {
     struct stat stat_tmp ;
     ret = stat( &mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
   }
   if( truss_stat==ON ) SYSMSG("stat_ret=0x%x\n",ret) ;
   mres->pc+=4 ; return(0) ;
 case 107: // lstat()
   if( truss_stat==ON ) SYSMSG("lstat(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     struct stat stat_tmp ;
     ret = lstat( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)], &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
   }
   mres->pc+=4 ; return(0) ;
 case 173: // rt_sigaction()
   if( truss_stat==ON ) SYSMSG("rt_sigaction(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     // always fail.
     mres->GPR[3].rl = -1 ;
     mres->GPR[0].rl = -1 ;
   }
   mres->pc+=4 ; return(0) ;
 case 108: // fstat()
   if( truss_stat==ON ) SYSMSG("fstat(0x%x,0x%x)",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     struct stat stat_tmp ;
     ret = fstat( (int)mres->GPR[3].rl+top_fd, &stat_tmp ) ;
     stat_cpyto32( &stat_tmp, mres, mres->GPR[4].rl ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
   }
   if( truss_stat==ON ) SYSMSG(" ===> ret %08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 181: // chown()
   if( truss_stat==ON ){
     SYSMSG("chown( %s , 0x%x , 0x%x )\n",
	    (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
	    mres->GPR[4].rl,
	    mres->GPR[5].rl ) ;
   }
   ret = chown( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		(uid_t)mres->GPR[4].rl,
		(gid_t)mres->GPR[5].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 182: // getcwd()
   if( truss_stat==ON ) SYSMSG("getcwd(0x%x,0x%x)\n",mres->GPR[3].rl,mres->GPR[4].rl) ;
   ret = (unsigned int)getcwd( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
			       (int)mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 197: // fstat64()
   if( truss_stat==ON ) SYSMSG("fstat64(0x%x,0x%x)",mres->GPR[3].rl,mres->GPR[4].rl) ;
   {
     struct stat stat_tmp ;
     ret = fstat( (int)mres->GPR[3].rl+top_fd, &stat_tmp ) ;
     stat_cpyto64( &stat_tmp, mres, mres->GPR[4].rl ) ;
     mres->GPR[3].rl = ret ;
     mres->GPR[0].rl = errno ;
   }
   if( truss_stat==ON ) SYSMSG(" ===> ret %08x\n",mres->GPR[3].rl) ;
   mres->pc+=4 ; return(0) ;
 case 200: // isatty()
   if( truss_stat==ON ) SYSMSG("isatty(%d)\n",mres->GPR[3].rl) ;
   ret = isatty( (int)mres->GPR[3].rl+top_fd ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 case 202: // sbrk()
   if( truss_stat==ON ) SYSMSG("sbrk=(0x%08x)\n",mres->GPR[3].rl) ;
   size=(int)mres->GPR[3].rl ;
   if( (size%4)!=0 ) size=((size/4)+1)*4 ; // alignment 4byte boundary
   if( ( (mres->heap_cur+size) >= mres->heap_size) ||
       ( (mres->heap_cur+size) < 0 ) ){
     mres->GPR[3].rl = 0xffffffff ;
     mres->GPR[0].rl = 12 ; /** ENOMEM **/
   }else{
     mres->GPR[3].rl = mres->heap_top+mres->heap_cur ;
     mres->heap_cur+= size ;
   }
   mres->pc+=4 ; return(0) ;
 case 203: // pathconf()
   if( truss_stat==ON ){
     SYSMSG("pathconf(0x%x,0x%x)\n",
	    mres->GPR[3].rl,mres->GPR[4].rl) ;
   }
   ret = pathconf( (char *)&mres->mem[seg(mres->GPR[3].rl)][lad(mres->GPR[3].rl)],
		   (int)mres->GPR[4].rl ) ;
   mres->GPR[3].rl = ret ;
   mres->GPR[0].rl = errno ;
   mres->pc+=4 ; return(0) ;
 }
 
 return(UNKNOWN_SYSCALL_NO) ;

#else

 return(NOT_SUPPORT_SC_EMU) ;

#endif
}

void open_mode_exchg(int *mode1 , int *mode2 , struct MACHINE_RESOURCE *mres )
{
  /*
    open()̃tOւ
  */
  switch( sc_emu_mode ) {
  case LINUXPPC :
    {
      unsigned int new_mode=0 ;
      if( (mres->GPR[4].rl & 0x01 )!=0 ) new_mode |= O_WRONLY ;
      if( (mres->GPR[4].rl & 0x02 )!=0 ) new_mode |= O_RDWR   ;
      if( (mres->GPR[4].rl & 0x40 )!=0 ) new_mode |= O_CREAT  ;
      if( (mres->GPR[4].rl & 0x80 )!=0 ) new_mode |= O_EXCL   ;
      if( (mres->GPR[4].rl & 0x100)!=0 ) new_mode |= O_NOCTTY ;
      if( (mres->GPR[4].rl & 0x200)!=0 ) new_mode |= O_TRUNC  ;
      if( (mres->GPR[4].rl & 0x400)!=0 ) new_mode |= O_APPEND ;
      if( (mres->GPR[4].rl & 0x800)!=0 ) new_mode |= O_NONBLOCK ;
      *mode1 = new_mode | O_BINARY ; /*** force binary mode ***/
      *mode2 = mres->GPR[5].rl ;
    }
    break ;
  default : /* NEWLIBPPC */
    *mode1=mres->GPR[4].rl | O_BINARY ; /*** force binary mode ***/
    *mode2=mres->GPR[5].rl ;
  }
}

void stat_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP2B(ptr[ 0]) ;/*stat->st_dev*/
  /*ptr[2],ptr[3]̓E߂̌*/
  SWAP4B(ptr[ 4]) ;/*stat->st_ino*/
  SWAP4B(ptr[ 8]) ;/*stat->st_mode*/
  SWAP2B(ptr[12]) ;/*stat->st_nlink*/
  SWAP2B(ptr[14]) ;/*stat->st_uid*/
  SWAP2B(ptr[16]) ;/*stat->st_gid*/
  SWAP2B(ptr[18]) ;/*stat->st_rdev*/
  SWAP4B(ptr[20]) ;/*stat->st_size*/
  SWAP4B(ptr[24]) ;/*stat->st_atime*/
  SWAP4B(ptr[28]) ;/*stat->st_spare1*/
  SWAP4B(ptr[32]) ;/*stat->st_mtime*/
  SWAP4B(ptr[36]) ;/*stat->st_spare2*/
  SWAP4B(ptr[40]) ;/*stat->st_ctime*/
  SWAP4B(ptr[44]) ;/*stat->st_spare3*/
  SWAP4B(ptr[48]) ;/*stat->st_blksize*/
  SWAP4B(ptr[52]) ;/*stat->st_blocks*/
  SWAP4B(ptr[56]) ;/*stat->st_spare4[0]*/
  SWAP4B(ptr[60]) ;/*stat->st_spare4[1]*/
}

void DIR_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    DIR\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*DIR->__d_cookie*/
  SWAP4B(ptr[ 4]) ;/*DIR->*__d_dirent*/
  SWAP4B(ptr[ 8]) ;/*DIR->*__d_dirname*/
  SWAP4B(ptr[12]) ;/*DIR->*__d_position*/
  SWAP4B(ptr[16]) ;/*DIR->__d_dirhash*/
  /*char^zȂ̂ősv*//*DIR->__d_u.__d_filler[16]*/
}

void dirent_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    dirent\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*dirent->__d_reserved[0]*/
  SWAP4B(ptr[ 4]) ;/*dirent->__d_reserved[1]*/
  SWAP4B(ptr[ 8]) ;/*dirent->__d_reserved[2]*/
  SWAP4B(ptr[12]) ;/*dirent->__d_reserved[3]*/
  SWAP4B(ptr[16]) ;/*dirent->__d_ino*/
  /*char^zȂ̂ősv*//*dirent->__d_u.__d_name[256]*/
}

void set_DIR_entry( unsigned int adrs , DIR *dirpt )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==0 ){
     dir_list[i].ppc_mem_ptr=adrs ;
     dir_list[i].cygwin_DIR =dirpt ;
     break ;
   }
 }
#endif
}

void remove_DIR_entry( unsigned int adrs )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     dir_list[i].ppc_mem_ptr=0 ;
     dir_list[i].cygwin_DIR =NULL ;
     break ;
   }
 }
#endif
}

DIR* search_DIR_entry( unsigned int adrs )
{
#ifdef SUPPORT_SYSTEMCALL_EMULATION
int i ;

 for( i=0 ; i<DIR_ENTRY_MAX ; i++ ){
   if( dir_list[i].ppc_mem_ptr==adrs ){
     return(dir_list[i].cygwin_DIR) ;
   }
 }
 return(NULL) ;
#else
 return(NULL) ;
#endif
}

void timbuf_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timbuf\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timbuf->actime*/
  SWAP4B(ptr[ 4]) ;/*timbuf->modtime*/
}

void tm_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    tm\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*tm->tm_sec*/
  SWAP4B(ptr[ 4]) ;/*tm->tm_min*/
  SWAP4B(ptr[ 8]) ;/*tm->tm_hour*/
  SWAP4B(ptr[12]) ;/*tm->tm_mday*/
  SWAP4B(ptr[16]) ;/*tm->tm_mon*/
  SWAP4B(ptr[20]) ;/*tm->tm_year*/
  SWAP4B(ptr[24]) ;/*tm->tm_wday*/
  SWAP4B(ptr[28]) ;/*tm->tm_yday*/
  SWAP4B(ptr[32]) ;/*tm->tm_isdst*/
}

void timeval_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timeval\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timeval->tv_sec*/
  SWAP4B(ptr[ 4]) ;/*timevel->tv_usec*/
}

void timezone_exchg( struct MACHINE_RESOURCE *mres, int adrs )
{
  unsigned char *ptr ;
  /*
    timezone\̃o[̃GfBA𔽓]
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;
  
  SWAP4B(ptr[ 0]) ;/*timezone->tz_minuteswest*/
  SWAP4B(ptr[ 4]) ;/*timezone->tzdsttime*/
}


void stat_cpyto32( struct stat *st, struct MACHINE_RESOURCE *mres, unsigned int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[Rs[
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;

  *(short*)(&ptr[ 0])=st->st_dev       ; SWAP2B(ptr[ 0]) ;
  *(int*  )(&ptr[ 4])=st->st_ino       ; SWAP4B(ptr[ 4]) ;
  *(int*  )(&ptr[ 8])=st->st_mode      ; SWAP4B(ptr[ 8]) ;
  *(short*)(&ptr[12])=st->st_nlink     ; SWAP2B(ptr[12]) ;
  *(short*)(&ptr[14])=st->st_uid       ; SWAP2B(ptr[14]) ;
  *(short*)(&ptr[16])=st->st_gid       ; SWAP2B(ptr[16]) ;
  *(short*)(&ptr[18])=st->st_rdev      ; SWAP2B(ptr[18]) ;
  *(int*  )(&ptr[20])=st->st_size      ; SWAP4B(ptr[20]) ;
  *(int*  )(&ptr[24])=st->st_atime     ; SWAP4B(ptr[24]) ;
  //  *(int*  )(&ptr[28])=st->st_spare1    ; SWAP4B(ptr[28]) ;
  *(int*  )(&ptr[32])=st->st_mtime     ; SWAP4B(ptr[32]) ;
  //  *(int*  )(&ptr[36])=st->st_spare2    ; SWAP4B(ptr[36]) ;
  *(int*  )(&ptr[40])=st->st_ctime     ; SWAP4B(ptr[40]) ;
  //  *(int*  )(&ptr[44])=st->st_spare3    ; SWAP4B(ptr[44]) ;
  *(int*  )(&ptr[48])=st->st_blksize   ; SWAP4B(ptr[48]) ;
  *(int*  )(&ptr[52])=st->st_blocks    ; SWAP4B(ptr[52]) ;
  *(int*  )(&ptr[56])=st->st_spare4[0] ; SWAP4B(ptr[56]) ;
  *(int*  )(&ptr[60])=st->st_spare4[1] ; SWAP4B(ptr[60]) ;
}


void stat_cpyto64( struct stat *st, struct MACHINE_RESOURCE *mres, unsigned int adrs )
{
  unsigned char *ptr ;
  /*
    stat\̃o[Rs[
  */
  ptr=&mres->mem[seg(adrs)][lad(adrs)] ;

  *(long long*)(&ptr[ 0])=(long long)st->st_dev    ; SWAP8B(ptr[ 0]) ;
  *(long long*)(&ptr[ 8])=(long long)st->st_ino    ; SWAP8B(ptr[ 8]) ;
  *(int*      )(&ptr[16])=(int      )st->st_mode   ; SWAP4B(ptr[16]) ;
  *(int*      )(&ptr[20])=(int      )st->st_nlink  ; SWAP4B(ptr[20]) ;
  *(int*      )(&ptr[24])=(int      )st->st_uid    ; SWAP4B(ptr[24]) ;
  *(int*      )(&ptr[28])=(int      )st->st_gid    ; SWAP4B(ptr[28]) ;
  *(long long*)(&ptr[32])=(long long)st->st_rdev   ; SWAP8B(ptr[32]) ;
  
  *(long long*)(&ptr[48])=(long long)st->st_size   ; SWAP8B(ptr[48]) ;
  *(int*      )(&ptr[56])=(int      )st->st_blksize; SWAP4B(ptr[56]) ;
  *(long long*)(&ptr[64])=(long long)st->st_blocks ; SWAP8B(ptr[64]) ;
  *(int*      )(&ptr[72])=(int      )st->st_atime  ; SWAP4B(ptr[72]) ;

  *(int*      )(&ptr[80])=(int      )st->st_mtime  ; SWAP4B(ptr[80]) ;

  *(int*      )(&ptr[88])=(int      )st->st_ctime  ; SWAP4B(ptr[88]) ;
}

/*****************************************************************************


  pathconf(),fpathconf()̎ɂāB
  newlibsysvi386ł͂̓VXeR[ƂĎĂB
  Linuxł(glibc琄) _statfs()VXeR[p pathconf
  libcX68kł͌ŒlԂlȃX^uŎB
  ߂lւlȌ`ŎĂB
  Cygwinł_statfs()gȂ̂ŁApathconf(),fpathconf()̓VXeR[
  ƂĒ`KvB

  readlink()
  Linuxł̓VXeR[ƂĒ`ĂB
  CygwinłVXeR[ƂĒ`ĂH
  libcX68kłsymlinkhCogpDOSR[ƂăG~[gB
*****************************************************************************/
